/* ====================================
		o[W_CAO
==================================== */
#include "stdafx.h"
#include "gdippManager.h"


/* ====================================
		錾
==================================== */
static void SetSystemInfoText(LPTSTR verInfo);
static bool SetModuleVerText(HWND hEdit);
bool SetModuleFileTimeText(HWND hEdit);
BOOL CALLBACK AboutDlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);


/* ====================================
		ϐ
==================================== */
namespace {
	TCHAR g_modulePath[MAX_PATH +1] = _T("");	// ƑΏۂ̃t@CpX
}


/* ====================================
		`
==================================== */
// modulePath̃o[W\
INT_PTR ShowAboutDlg(HWND hWnd, LPCTSTR modulePath)
{
	lstrcpyn(g_modulePath, modulePath, lengthof(g_modulePath));
	SetForegroundWindow(hWnd);
	return DialogBox(g_hInst, MAKEINTRESOURCE(IDD_ABOUT), hWnd, AboutDlgProc);
}

// VXe擾ăGfBbgɓ\t
static bool SetSystemInfoText(HWND hEdit)
{
	TCHAR buf[128];
	OSVERSIONINFO osInfo;
	osInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if (!GetVersionEx(&osInfo)) {
		return false;
	}
	wsprintf(buf, _T("Windows: %d.%d.%d.%s"),
		osInfo.dwMajorVersion, osInfo.dwMinorVersion,
		osInfo.dwBuildNumber, osInfo.szCSDVersion);

	AddWindowText(hEdit, _T("ySystemz"));
	AddWindowText(hEdit, buf, true);

	HDC hdc = GetDC(NULL);
	wsprintf(buf, _T("Screen: %u x %u x %u bpp"),
		GetSystemMetrics(SM_CXSCREEN),
		GetSystemMetrics(SM_CYSCREEN),
		GetDeviceCaps(hdc, BITSPIXEL));
	ReleaseDC(NULL, hdc);
	AddWindowText(hEdit, buf, true);

	return true;
}

// t@Co[W擾ăGfBbgɓ\t
static bool SetModuleVerText(HWND hEdit)
{
	TCHAR title[64];
	wsprintf(title, _T("y%sz"), PathFindFileName(g_modulePath));
	AddWindowText(hEdit, title);

	DWORD sz;
	sz = GetFileVersionInfoSize(g_modulePath, &sz);
	if (sz == 0) {
		return false;
	}

	LPVOID lpData;
	lpData = new TCHAR[sz];
	if (!GetFileVersionInfo(g_modulePath, 0, sz, lpData)) {
		return false;
	}

	UINT dummy;
	WORD* wLangId;
	VerQueryValue(lpData, _T("\\VarFileInfo\\Translation"),
		reinterpret_cast<LPVOID*>(&wLangId), &dummy);

	// \JeS
	static LPCTSTR category[] = {
		_T("FileVersion"),
		_T("Comments"),
	};
	for (int i=0 ; i<lengthof(category) ; ++i) {
		LPVOID lpBuffer;
		TCHAR format[64], moduleInfo[1024];

		wsprintf(format, _T("%s: "), category[i]);
		AddWindowText(hEdit, format, true);

		wsprintf(format, _T("\\StringFileInfo\\%04X%04X\\%s"),
			wLangId[0], wLangId[1], category[i]);
		if (VerQueryValue(lpData, format, &lpBuffer, &dummy)) {
			wsprintf(moduleInfo, _T("%s"), lpBuffer);
			AddWindowText(hEdit, moduleInfo);
		} else {
			//	̍ڒl͎擾łȂ
		}
	}
	return true;
}

// t@C̍XV擾ăGfBbgɓ\t
bool SetModuleFileTimeText(HWND hEdit)
{
	HANDLE hFile = CreateFile(g_modulePath, GENERIC_READ, 0, NULL,
														OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		return false;
	}

	FILETIME ftFileTime,
					 ftLocalFileTime;
	SYSTEMTIME stFileTime;
	GetFileTime(hFile, NULL, NULL, &ftFileTime);
	FileTimeToLocalFileTime(&ftFileTime, &ftLocalFileTime);
	FileTimeToSystemTime(&ftLocalFileTime, &stFileTime);

	TCHAR strFileTime[64];
	wsprintf(strFileTime, _T("XV: %dN%d%dA%d:%d:%d"),
						stFileTime.wYear, stFileTime.wMonth,
						stFileTime.wDay, stFileTime.wHour,
						stFileTime.wMinute, stFileTime.wSecond);

	AddWindowText(hEdit, strFileTime, true);
	CloseHandle(hFile);
	return true;
}

// e擾āARg[̕\M
BOOL AboutDlg_OnInitDialog(HWND hWnd, WPARAM, LPARAM)
{
	const HWND hEdit = GetDlgItem(hWnd, IDC_VERSION);

	// VXeƃoCi
	SetSystemInfoText(hEdit);
	AddWindowText(hEdit, _T("\r\n\r\n"));
	if (!SetModuleVerText(hEdit)) {
		SetModuleFileTimeText(hEdit);
		AddWindowText(hEdit, _T("@o[W͓ǂݍ߂܂ł"), true);
	}

	// LvVύX
	AddWindowPathText(hWnd, g_modulePath);

	// tHgݒ
	HDC hdc      = GetDC(hEdit);
	LOGFONT lf   = {0};
	lf.lfHeight  = -MulDiv(10, GetDeviceCaps(hdc, LOGPIXELSY), 72);
	lf.lfCharSet = SHIFTJIS_CHARSET;
	lstrcpy(lf.lfFaceName, _T("Terminal"));
	ReleaseDC(hEdit, hdc);
	HFONT hfont  = CreateFontIndirect(&lf);
	SetWindowFont(hEdit, hfont, FALSE);

	HWND hURLCtl = GetDlgItem(hWnd, IDC_URL);
	hfont        = GetWindowFont(hURLCtl);
	GetObject(hfont, sizeof(LOGFONT), &lf);
	lf.lfUnderline = TRUE;	//t
	hfont = CreateFontIndirect(&lf);
	SetWindowFont(hURLCtl, hfont, FALSE);

	//URL{^̃TCY
	SIZE size;
	RECT rect;
	TCHAR szUrl[128];
	GetWindowRect(hURLCtl, &rect);
	MapWindowPoints(HWND_DESKTOP, hWnd, reinterpret_cast<LPPOINT>(&rect), 2);
	hdc   = GetDC(hURLCtl);
	hfont = static_cast<HFONT>(SelectObject(hdc, hfont));
	GetTextExtentPoint32(hdc, szUrl, GetWindowText(hURLCtl, szUrl, 128) +1, &size);
	SelectObject(hdc, hfont);
	ReleaseDC(hURLCtl, hdc);
	size.cx += 4;
	size.cy += 4;
	SetWindowPos(hURLCtl, NULL,
		rect.right - size.cx, rect.bottom - size.cy,
		size.cx, size.cy, SWP_NOZORDER);

	//c[`bv
	TOOLINFO ti;
	ti.cbSize   = sizeof(TOOLINFO);
	ti.uFlags   = TTF_IDISHWND | TTF_SUBCLASS;
	ti.hwnd     = hURLCtl;
	ti.uId      = reinterpret_cast<UINT>(hURLCtl);
	GetClientRect(hWnd, &ti.rect);
	ti.hinst    = NULL;
	ti.lpszText = _T("{WebTCg\");
	HWND hTip = CreateWindowEx(
		0, TOOLTIPS_CLASS, NULL, TTS_ALWAYSTIP,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		hWnd, NULL, NULL, NULL);
	SendMessage(hTip, TTM_ADDTOOL, 0, reinterpret_cast<LPARAM>(&ti));

	// TRUE Ԃꍇ́Aŏ WS_TABSTOP Rg[
	// tH[JXZbg܂
	return TRUE;
}

BOOL AboutDlg_OnClose(HWND hWnd, WPARAM, LPARAM)
{
	EndDialog(hWnd, IDOK);
	return FALSE;
}

// OnInitDialogōtHgj
BOOL AboutDlg_OnDestroy(HWND hWnd, WPARAM, LPARAM)
{
	HFONT hfont = reinterpret_cast<HFONT>(SendDlgItemMessage(hWnd, IDC_VERSION, WM_GETFONT, 0, 0));
	if (hfont) {
		DeleteObject(hfont);
	}
	hfont = reinterpret_cast<HFONT>(SendDlgItemMessage(hWnd, IDC_URL, WM_GETFONT, 0, 0));
	if (hfont) {
		DeleteObject(hfont);
	}
	return FALSE;
}

// J[\ύX
BOOL AboutDlg_OnSetCursor(HWND hWnd, WPARAM wParam, LPARAM)
{
	if (reinterpret_cast<HWND>(wParam) == GetDlgItem(hWnd, IDC_URL)) {
		SetCursor(LoadCursor(NULL, IDC_HAND));
		SetWindowLongPtr(hWnd, DWLP_MSGRESULT, TRUE);
		return TRUE;
	}
	return FALSE;
}

// URLRg[̕`
BOOL AboutDlg_OnDrawItem(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if (wParam != IDC_URL || !lParam) {
		return FALSE;
	}

	const LPDRAWITEMSTRUCT lpdis = reinterpret_cast<const LPDRAWITEMSTRUCT>(lParam);
	RECT rect = lpdis->rcItem;

	HBRUSH hBrush = (HBRUSH)SendMessage(hWnd, WM_CTLCOLORSTATIC,
		reinterpret_cast<WPARAM>(lpdis->hDC), reinterpret_cast<LPARAM>(lpdis->hwndItem));
	FillRect(lpdis->hDC, &rect, hBrush);
	if (lpdis->itemState & ODS_FOCUS) {
		DrawFocusRect(lpdis->hDC, &rect);
	}

	InflateRect(&rect, -2, -2);
	const COLORREF oldfg = SetTextColor(lpdis->hDC,
		(lpdis->itemState & ODS_SELECTED) ? RGB(255, 0, 0) : RGB(0, 0, 255));
	const int oldbk = SetBkMode(lpdis->hDC, TRANSPARENT);
	TCHAR szUrl[128];
	const int cch = GetWindowText(lpdis->hwndItem, szUrl, 128);
	DrawText(lpdis->hDC, szUrl, cch, &rect,
		DT_VCENTER | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
	SetBkMode(lpdis->hDC, oldbk);
	SetTextColor(lpdis->hDC, oldfg);
	SetWindowLongPtr(hWnd, DWLP_MSGRESULT, TRUE);
	return TRUE;
}

BOOL AboutDlg_OnCommand(HWND hWnd, WPARAM wParam, LPARAM)
{
	switch (LOWORD(wParam)) {
	case IDOK:
		SendMessage(hWnd, WM_CLOSE, 0, 0);
		break;
	case IDC_URL:
		{
			TCHAR szUrl[128];
			GetDlgItemText(hWnd, IDC_URL, szUrl, 128);
			ShellExecute(GetDesktopWindow(), _T("open"), szUrl, NULL, NULL, SW_SHOWNORMAL);
		}
		break;
	}
	return TRUE;
}

// _CAOvVW
BOOL CALLBACK AboutDlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	HANDLE_DLGMSG(hWnd, WM_INITDIALOG, AboutDlg_OnInitDialog);
	HANDLE_DLGMSG(hWnd, WM_CLOSE, AboutDlg_OnClose);
	HANDLE_DLGMSG(hWnd, WM_DESTROY, AboutDlg_OnDestroy);
	HANDLE_DLGMSG(hWnd, WM_SETCURSOR, AboutDlg_OnSetCursor);
	HANDLE_DLGMSG(hWnd, WM_DRAWITEM, AboutDlg_OnDrawItem);
	HANDLE_DLGMSG(hWnd, WM_COMMAND, AboutDlg_OnCommand);
	}
	return FALSE;
}

/* ----------------------------------
	CompanyName      Ж
	FileDescription  
	FileVersion      t@Co[W
	InternalName     
	LegalCopyright   쌠
	OriginalFileName t@C
	ProductName      i
	ProductVersion   io[W
	Comments         Rg
	LegalTrademarks  W
	PrivateBuild     vCx[grh
	SpecialBuild     XyVrh
---------------------------------- */

// EOF
