#pragma once

#include "gdippManager.rc"

#pragma comment(lib, "kernel32.lib")
#pragma comment(lib, "user32.lib")
#pragma comment(lib, "gdi32.lib")
#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "version.lib")
#pragma comment(lib, "shell32.lib")
#pragma comment(lib, "shlwapi.lib")
#pragma comment(lib, "advapi32.lib")


// `ĂGUIł͂ȂINIڕҏWɂȂ
#define  NO_GUI


/* ====================================
		define
==================================== */
// API to CRT
//#define _CRT_SECURE_CPP_OVERLOAD_STANDARD_NAMES       1
//#define _CRT_SECURE_CPP_OVERLOAD_STANDARD_NAMES_COUNT 1
//#define _CRT_SECURE_CPP_OVERLOAD_SECURE_NAMES         1
//#define _CRT_SECURE_NO_DEPRECATE                      1
//#define lstrlen                 _tcslen
//#define lstrcpy                 _tcscpy
//#define lstrcpy(lhs, rhs)      (lstrcpyn(lhs, rhs, lengthof(lhs)))
//#define lstrcpyn(lhs, rhs, sz) (_tcscpy_s(lhs, sz, rhs))
//#define lstrcmpi                _tcsicmp
//#define lstrcmp                 _tcscmp
//#define lstrcat                 _tcscat

#define lengthof(Array) (sizeof((Array)) / sizeof((Array)[0]))
#define toString(str)   #str
#define WM_TASKTRAY     (WM_APP+1)
#define WM_INITHOOK     (WM_APP+2)
#define WM_TERMHOOK     (WM_APP+3)

// I\[XID
#define ID_APP_MIN      0x8000
#define IDM_DLL_MIN     (ID_APP_MIN)         // IDLLj[ID
#define IDM_DLL_MAX     (IDM_DLL_MIN +1000)  // IDM_DLL_MIN`IDM_DLL_MAX
#define ID_APP_MAX      0xFFFF

// BOOL Cls_OnDialogMsg(HWND hWnd, WPARAM wParam, LPARAM lParam)
#define HANDLE_DLGMSG(hWnd, message, fn) \
    case (message): return (BOOL)(fn)((hWnd), (wParam), (lParam))

// void Cls_OnNull(HWND hWnd, WPARAM wParam, LPARAM lParam)
#define HANDLE_WM_NULL(hWnd, wParam, lParam, fn) \
    ((fn)((hWnd), (wParam), (lParam)), 0L)

// void Cls_OnTaskTray(HWND hWnd, int id, UINT uMsg)
#define HANDLE_WM_TASKTRAY(hWnd, wParam, lParam, fn) \
    ((fn)(hWnd, (int)(wParam), (UINT)(lParam)), 0L)

// void Cls_OnInitHook(HWND hWnd, int result, int redraw, const GdiDllInfo* lpDllInfo)
#define HANDLE_WM_INITHOOK(hwnd, wParam, lParam, fn) \
    ((fn)((hwnd), (int)(LOWORD(wParam)), (int)(HIWORD(wParam)), (const GdiDllInfo*)(lParam)), 0L)

// void Cls_OnTermHook(HWND hWnd, int redraw)
#define HANDLE_WM_TERMHOOK(hwnd, wParam, lParam, fn) \
    ((fn)((hwnd), (int)(wParam)), 0L)


/* ====================================
		錾
==================================== */
static const TCHAR WINCL_NAME[] = _T("gdi++Manager");
static const TCHAR INI_NAME[]   = _T("gdi++.ini");
static const TCHAR DLL_NAME[]   = _T("gdi++.dll");

class NoCopy;
class GdiDllInfo;
class MutexResource;
class MenuResource;
class ShellIconResource;
class DllResource;
class DllUser;
class Argv;

// gdippManager.cpp
int ErrMsg(LPCTSTR uMsg = _T("default message"));
void DbgMsg(LPCTSTR uMsg);
BOOL PathRemoveFileSpecCpy(LPTSTR path, LPCTSTR basepath = NULL, int length = 0);
void AddWindowText(HWND hTrgWnd, LPCTSTR text, bool newLine = false);
void AddWindowPathText(HWND hWnd, LPCTSTR path);
void Ini_GeneralToStr(LPTSTR tipbuf, LPCTSTR path);
void Ini_FreeTypeToStr(LPTSTR tipbuf, LPCTSTR path);
void ResetHook(const GdiDllInfo& dllInfo);
VOID CALLBACK ResetHook_TimerProc(HWND hWnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime);

// msinMsgProc.cpp
LRESULT CALLBACK MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

// aboutDlg.cpp
INT_PTR ShowAboutDlg(HWND hWnd, LPCTSTR modulePath);


/* ====================================
		typedef
==================================== */

// INIt@C̏

//const UINT MAX_LIST         = 32;
//const UINT MAX_FONTLIST_BUF = LF_FACESIZE * MAX_LIST + MAX_LIST + 1;
//const UINT MODULENAME_SIZE  = 80;
//const UINT MAX_MODULELIST_BUF = MODULENAME_SIZE * MAX_LIST + MAX_LIST + 1;
//
//typedef struct {
//	UINT Quality;
//	UINT Weight;
//	UINT Enhance;
//	UINT MaxHeight;
//	UINT UseSubPixel;
//	UINT SubPixelDirection;
//	UINT ForceAntialiasedQuality;
//	UINT UseNewRasterizer;
//	UINT HookChildProcesses;
//} INIGENEAL, *LPINIGENEAL;
//
//// ̕ӂ̓Xg\ɂ邩H
//typedef struct {
//	TCHAR FontNames[MAX_FONTLIST_BUF];
//	TCHAR ModuleNames[MAX_MODULELIST_BUF];
//} INIEXCLUDE, *LPINIEXCLUDE;
//
//typedef struct {
//	TCHAR Names[MAX_FONTLIST_BUF];
//	UINT  Weights[MAX_LIST];
//} INIINDIVIDUAL, *LPINIINDIVIDUAL;

// //


// pƕ֎~ɂȂ
class NoCopy {
	NoCopy& operator =(const NoCopy&);
	NoCopy(const NoCopy&);

protected:
	NoCopy() {}
	~NoCopy() {}
};

// DLLʂ̃f[^NX
class GdiDllInfo {
	bool IsEqual(const GdiDllInfo& rhs) const;
public:
	TCHAR dirPath[MAX_PATH +1];
	int   searchType;

	GdiDllInfo()
		{ this->Clear(); }
	GdiDllInfo(LPCTSTR path, int type);
	const GdiDllInfo& operator =(const GdiDllInfo& rhs);
	const bool operator ==(const GdiDllInfo& rhs) const;
	const bool operator !=(const GdiDllInfo& rhs) const;
	void Clear();
	bool IsEmpty() const;
};

// ~[ebNX̊ǗNX
class MutexResource : private NoCopy {
	template <typename T> friend std::auto_ptr<T> CreateInst();
	static const long MAX_INST = 1;
	static long instCount;
	HANDLE hMutexRes;

	MutexResource() : hMutexRes(NULL) {}
	MutexResource(const MutexResource&) {}

public:
	~MutexResource();
	bool IsCreated();
};

// j[̊ǗNX
class MenuResource : private NoCopy {
	HMENU hMenuRes;

public:
	MenuResource(HMENU hMenu) : hMenuRes(hMenu) {}
	~MenuResource()
		{ DestroyMenu(hMenuRes); }
	HMENU get() const
		{ return hMenuRes; }
	HMENU getTray() const
		{ return GetSubMenu(hMenuRes, 0); }
};

// gCACR̊ǗNX
class ShellIconResource : private NoCopy {
	NOTIFYICONDATA nid;

public:
	~ShellIconResource()
		{ Shell_NotifyIcon(NIM_DELETE, &this->nid); }
	void Init(HWND hWnd);
	bool Add();
	bool Modify(UINT uResId, LPCTSTR pszTip = WINCL_NAME);
};

// DLLQ̏ƓIj[̋@\
// RefreshDllMenug胁j[DLL͘A(͂
class DllResource : private NoCopy {
	template <typename T> friend std::auto_ptr<T> CreateInst();
	static const long MAX_INST = 1;
	static long instCount;
	std::vector<GdiDllInfo> dllInfo;
	enum {	// ̒l͕KƁł͂Ȃ
		APPLI, CURRENT, SYSTEM32, SYSTEM16, WINDOWS, ENVIRON, SUBDIR,
	};

	DllResource() {}
	void PushDllInfo(LPCTSTR path, int searchType);
	void doSetDllInfo(std::vector< std::basic_string<TCHAR> >& pathContainer,
										int searchType,
										LPCTSTR searchPath = _T(""));
	void SetDllInfo();
	void CreateDllMenu(HMENU hTrayMenu);
	void DestroyDllMenu(HMENU hTrayMenu) const;

public:
	~DllResource()
		{ InterlockedDecrement(&instCount); }
	void RefreshDllMenu(HMENU hTrayMenu);
	void RefreshDllMenu(HMENU hTrayMenu, const GdiDllInfo& deleteInfo);
	void GetFirstDllInfo(GdiDllInfo& dllInfo) const;
	UINT GetDllCount() const
		{ return static_cast<UINT>(this->dllInfo.size()); }
	void OnDrawItem(HWND hWnd, const DRAWITEMSTRUCT* lpdis) const;
};

// DLLۂɗp@\̒
class DllUser : private NoCopy {
	template <typename T> friend std::auto_ptr<T> CreateInst();
	static const long MAX_INST = 1;
	static long instCount;
	HHOOK hHook;
	GdiDllInfo usingDll;

	DllUser() : hHook(NULL) {}
	DllUser(const DllUser&) {}

public:
	~DllUser();
	void OnMenuCommand(HWND hWnd, int id);
	bool InitHook(const GdiDllInfo& useDll, bool redraw = true);
	void TermHook(bool redraw = true);
	void GetUsingDllInfo(GdiDllInfo& dllInfo) const;
	bool IsUsingDll() const
		{ return (this->hHook != NULL); }
};

// ǂݎp__targv[0]
class Argv : private NoCopy {
	TCHAR argv[MAX_PATH +1];

	Argv(const Argv&) {}

public:
	operator LPCTSTR() const
		{ return argv; }
	Argv()
		{ GetModuleFileName(GetModuleHandle(NULL), this->argv, lengthof(argv)); }
};


/* ====================================
		ϐ
==================================== */
extern DllResource&        g_dllres;
extern DllUser&            g_dlluser;
extern const MenuResource& g_menures;
extern const HINSTANCE     g_hInst;
extern int                 g_ret;
extern const Argv          g_argv;


/* ====================================
		`
==================================== */
// włx
template <typename T>
int ErrMsg(LPCTSTR uMsg, const T code, LPCTSTR format = _T("%s\nCode:%d"))
{
	TCHAR buf[1024];
	wnsprintf(buf, lengthof(buf), format, uMsg, code);
	return MessageBox(NULL, buf, WINCL_NAME, MB_ICONWARNING | MB_TOPMOST);
}

// CX^X̏łȂȂCX^X𐶐auto_ptrŕԂ
template <typename T>
std::auto_ptr<T> CreateInst()
{
	if (T::instCount >= T::MAX_INST) {
		// bad_alloc}~Ă̂NULLƎ󂯎肪
		// `FbN邱ƂɂȂ̂͂ǂȂł傤H łOMȂ(L֥`)
		return NULL;
	} else {
		std::auto_ptr<T> p(new T);
		InterlockedIncrement(&T::instCount);
		return p;
	}
}

// ReiɖvfȂ-1
template <typename T>
int GetItemIdx(const std::vector<T>& container, const T& item)
{
	int ret = 0;
	for (std::vector<T>::const_iterator iter = container.begin() ;
				iter != container.end() ;
				++iter, ++ret) {
		if (*iter == item) {		// pr֐̕CĈ
			return ret;
		}
	}
	return -1;
}

// EOF
